summaryrefslogtreecommitdiffstats
path: root/jjb/scripts/packagecloud_push.sh
diff options
context:
space:
mode:
Diffstat (limited to 'jjb/scripts/packagecloud_push.sh')
-rw-r--r--jjb/scripts/packagecloud_push.sh84
1 files changed, 52 insertions, 32 deletions
diff --git a/jjb/scripts/packagecloud_push.sh b/jjb/scripts/packagecloud_push.sh
index d7c33d54..6af2f512 100644
--- a/jjb/scripts/packagecloud_push.sh
+++ b/jjb/scripts/packagecloud_push.sh
@@ -1,44 +1,64 @@
#!/bin/bash
-# PCIO_CO is a Jenkins Global Environment variable
-set -x
+# Copyright (c) 2020 Cisco and/or its affiliates.
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at:
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+echo "---> jjb/scripts/packagecloud_push.sh"
+
+set -euxo pipefail
echo "STARTING PACKAGECLOUD PUSH"
sleep 10
-if [ -f /usr/bin/zypper ]; then
- FACTER_OS="openSUSE"
-else
- FACTER_OS=$(/usr/bin/facter operatingsystem)
-fi
+FACTER_OS=$(/usr/bin/facter operatingsystem)
+push_cmd=""
+# PCIO_CO and SILO are Jenkins Global Environment variables defined in
+# .../ci-management/jenkins-config/global-vars-*.sh
if [ -f ~/.packagecloud ]; then
case "$FACTER_OS" in
- Debian)
- FACTER_LSBNAME=$(/usr/bin/facter lsbdistcodename)
- DEBS=$(find . -type f -iname '*.deb')
- package_cloud push "${PCIO_CO}/${STREAM}/debian/${FACTER_LSBNAME}/main/" ${DEBS}
- ;;
- Ubuntu)
- FACTER_LSBNAME=$(/usr/bin/facter lsbdistcodename)
- DEBS=$(find . -type f -iname '*.deb')
- package_cloud push "${PCIO_CO}/${STREAM}/ubuntu/${FACTER_LSBNAME}/main/" ${DEBS}
- ;;
- CentOS)
- FACTER_OSMAJREL=$(/usr/bin/facter operatingsystemmajrelease)
- FACTER_ARCH=$(/usr/bin/facter architecture)
- RPMS=$(find . -type f -iregex '.*/.*\.\(s\)?rpm')
- package_cloud push "${PCIO_CO}/${STREAM}/el/${FACTER_OSMAJREL}/os/${FACTER_ARCH}/" ${RPMS}
- ;;
- openSUSE)
- # Use /etc/os-release on openSUSE to get $VERSION
- . /etc/os-release
- RPMS=$(find . -type f -iregex '.*/.*\.\(s\)?rpm' | grep -v 'vpp-ext-deps')
- VPP_EXT_RPMS=$(find . -type f -iregex '.*/.*\.\(s\)?rpm' | grep 'vpp-ext-deps')
- package_cloud push "${PCIO_CO}/${STREAM}/opensuse/${VERSION}/" ${RPMS}
- # This file may have already been uploaded. Don't error out if it exists.
- package_cloud push "${PCIO_CO}/${STREAM}/opensuse/${VERSION}/" ${VPP_EXT_RPMS} --skip-errors
- ;;
+ Debian)
+ FACTER_LSBNAME=$(/usr/bin/facter lsbdistcodename)
+ DEBS=$(find . -type f -iname '*.deb')
+ push_cmd="package_cloud push ${PCIO_CO}/${STREAM}/debian/${FACTER_LSBNAME}/main/ ${DEBS}"
+ ;;
+ Ubuntu)
+ FACTER_LSBNAME=$(/usr/bin/facter lsbdistcodename)
+ DEBS=$(find . -type f -iname '*.deb')
+ push_cmd="package_cloud push ${PCIO_CO}/${STREAM}/ubuntu/${FACTER_LSBNAME}/main/ ${DEBS}"
+ ;;
+ CentOS)
+ FACTER_OSMAJREL=$(/usr/bin/facter operatingsystemmajrelease)
+ FACTER_ARCH=$(/usr/bin/facter architecture)
+ RPMS=$(find . -type f -iregex '.*/.*\.\(s\)?rpm')
+ push_cmd="package_cloud push ${PCIO_CO}/${STREAM}/el/${FACTER_OSMAJREL}/os/${FACTER_ARCH}/ ${RPMS}"
+ ;;
+ *)
+ echo "ERROR: Unsupported OS '$FACTER_OS'"
+ echo "PACKAGECLOUD PUSH FAILED!"
+ exit 1
+ ;;
esac
+ if [ "${SILO,,}" = "sandbox" ] ; then
+ echo "SANDBOX: skipping '$push_cmd'"
+ else
+ $push_cmd
+ fi
+else
+ echo "ERROR: Missing '~/.packagecloud' for user '$(id)'"
+ echo "PACKAGECLOUD PUSH FAILED!"
+ exit 1
fi
+
+echo "PACKAGECLOUD PUSH COMPLETE"